﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI.WebControls;

namespace FWC {
	public class Pager : CompositeControl {
		int _pageIndex = 0;
		int _recordCount = 0;
		int _pageSize = 0;
		string _baseUrl = String.Empty;

		public int PageIndex {
			get { return _pageIndex; }
			set { _pageIndex = value; }
		}
		public int RecordCount {
			get { return _recordCount; }
			set { _recordCount = value; }
		}
		public int PageSize {
			get { return _pageSize; }
			set { _pageSize = value; }
		}
		public string BaseUrl {
			get { return _baseUrl; }
			set { _baseUrl = value; }
		}


		protected override void CreateChildControls() {
		}

		public override void RenderBeginTag(System.Web.UI.HtmlTextWriter writer) {
		}

		public override void RenderEndTag(System.Web.UI.HtmlTextWriter writer) {
		}

		protected override void OnPreRender(EventArgs e) {
			string url = BaseUrl + (BaseUrl.Contains("?") ? "&" : "?") + "Page=";
			int pageCount = (int)Math.Ceiling((double)(RecordCount/PageSize));
			for (int i = 1; i <= pageCount; i++) {
				if (i == PageIndex) {
					Literal page = new Literal();
					page.Text = "<strong>" + i.ToString() + "</strong>";
					Controls.Add(page);
				}
				else {
					HyperLink link = new HyperLink();
					link.Text = i.ToString();
					link.NavigateUrl = url + i;
					Controls.Add(link);
				}
				Controls.Add(GetSpaceChar());
			}
		}

		private Literal GetSpaceChar() {
			Literal l = new Literal();
			l.Text = " ";
			return l;
		}
	}
}