﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;

public partial class LINQToDataSet : System.Web.UI.Page {
	protected void ExecuteQuery(object sender, EventArgs e) {
		DataSet ds = new DataSet();
		using (SqlDataAdapter ad = new SqlDataAdapter("select * From orders", ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString)) {
			ad.Fill(ds, "orders");
		}

		DataTable orders = ds.Tables["orders"];
		var q = from o in orders.AsEnumerable()
						where o.Field<string>("CustomerID") == "ALFKI"
						select new
						{
							OrderID = o.Field<int>("OrderID"),
							ShipName = o.Field<string>("ShipName"),
							ShipAddress = o.Field<string>("ShipAddress"),
							ShipCity = o.Field<string>("ShipCity")
						};
		grd.DataSource = q;
		grd.DataBind();
	}

	protected void ExecuteJoin(object sender, EventArgs e) {
		DataSet ds = new DataSet();
		using (SqlDataAdapter ad = new SqlDataAdapter("select * From orders", ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString)) {
			ad.Fill(ds, "orders");
		}
		using (SqlDataAdapter ad = new SqlDataAdapter("select * From [order details]", ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString)) {
			ad.Fill(ds, "orderdetails");
		}
		DataTable orders = ds.Tables["orders"];
		DataTable details = ds.Tables["orderdetails"];

		var q = from o in orders.AsEnumerable()
						join d in details.AsEnumerable() on o.Field<int>("OrderID") equals d.Field<int>("OrderID")
						where o.Field<string>("CustomerID") == "ALFKI"
						select new
						{
							OrderID = o.Field<int>("OrderID"),
							Quantity = d.Field<Int16>("Quantity"),
							UnitPrice = d.Field<decimal>("UnitPrice")
						};
		grd.DataSource = q;
		grd.DataBind();
	}
}