﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.Linq;
using System.Collections.Generic;

public partial class LINQToObjects : Page {
	protected override void OnLoad(EventArgs e) {
		base.OnLoad(e);
		List<Persona> persone = Utility.RecuperaPersone();
		List<Persona> altrePersone = Utility.RecuperaAltrePersone();
		List<Persona> personeConDuplicati = Utility.RecuperaPersoneConDuplicati();

		/* Filtro per età con extension methods*/
		var p1 = persone.Where(p => p.Eta > 30);

		/* Filtro per età e ritorno di anonymous type con extension methods*/
		var p2 = persone.Where(p => p.Eta > 30).Select(p => new { p.Nome, p.Cognome });
	
		/* filtro Query expression */
		var p3 = from p in persone
						 where p.Eta > 30
						 select p;
		
		/* filtro e anonymous type con Query expression */
		var p4 = from p in persone
						 where p.Eta > 30
						 select new { p.Nome, p.Cognome };

		/* order by */
		var p5 = from p in persone
						 where p.Eta > 30
						 orderby p.Eta
						 select new { p.Nome, p.Cognome };
		
		/* Persone uniche in una lista */
		var p6 = personeConDuplicati.Distinct();

		/* Persone in una lista ed in un'altra*/
		var p7 = persone.Intersect(altrePersone);

		/* Persone in una lista non presenti in un'altra*/
		var p8 = persone.Except(altrePersone);

		/* unione di 2 liste senza duplicati */
		var p9 = persone.Union(altrePersone);

		grd.DataSource = p1;
		grd.DataBind();
	}
}