﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.Linq;
using System.Collections.Generic;

public partial class LINQToSql : System.Web.UI.Page {
	protected void Page_Load(object sender, EventArgs e) {
		using (NorthwindDataContext ctx = new NorthwindDataContext()) {
			//Query semplice sugli ordini del cliente ALFKI
			var q1 = from o in ctx.Orders
							where o.CustomerID == "ALFKI"
							select o;

			//Query complessa sugli ordini dei clienti italiani
			var q2 = from o in ctx.Orders
							where o.Customer.Country == "Italy"
							select o;

			//Query complessa con anonymus type di ritorno
			var q3 = from o in ctx.Orders
							 where o.Customer.Country == "Italy"
							 select new { o.OrderID, o.CustomerID };

			//Query complessa con sum
			var q4 = from o in ctx.Orders
							 select new { o.OrderID, Total = o.Order_Details.Sum(d => (d.Quantity * d.UnitPrice) - (decimal)d.Discount) };

			//Query con paginazione (pagina 1)
			var q7 = ctx.Customers.Skip(0).Take(10);

			//Query con paginazione (pagina 2)
			var q5 = ctx.Customers.Skip(10).Take(10);

			//Query con immediate loading degl cliente insieme agli ordini
			DataLoadOptions dlo = new DataLoadOptions();
			dlo.LoadWith<Order>(o => o.Customer);
			ctx.LoadOptions = dlo;

			var q6 = from o in ctx.Orders
							 where o.Customer.Country == "Italy"
							 select o;

			grd.DataSource = q7;
			grd.DataBind();
		}
	}
}