﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;

public partial class LinqToXML : System.Web.UI.Page {
	protected void CreaXML(object sender, EventArgs e) {
		ltl.Text = Server.HtmlEncode(CreaXML().ToString()).Replace("\r\n", "<br/>").Replace(" ", "&nbsp;");
	}

	protected void FiltraEta(object sender, EventArgs e) {
		XDocument doc = CreaXML();

		var c = from el in doc.Element("Persone").Elements("Persona")
						where Convert.ToInt32(el.Element("Eta").Value) > 30
						select new { Nome = el.Element("Nome").Value, Cognome = el.Element("Cognome").Value };

		grd.DataSource = c;
		grd.DataBind();
	}

	XDocument CreaXML() {
		List<Persona> persone = Utility.RecuperaPersone();

		return new XDocument(
			new XElement("Persone",
				from p in persone
				select new XElement("Persona",
					new XElement("Nome", p.Nome),
					new XElement("Cognome", p.Cognome),
					new XElement("Eta", p.Eta)
				)
			)
		);

		/*return new XDocument(new XDeclaration("1.0", "UTF-8", "Yes"), new XElement("persone",
			from p in persone
			select new XElement("persona",
				new XAttribute("Nome", p.Nome),
				new XAttribute("Cognome", p.Cognome),
				new XAttribute("Eta", p.Eta),
				new XAttribute("DataNascita", p.DataNascita.ToString("yyyyMMdd")))));*/
	}

	protected void JoinXMLObject(object sender, EventArgs e) {
		List<Persona> altrePersone = Utility.RecuperaAltrePersone();
		XDocument doc = CreaXML();

		var r = from q in doc.Elements("Persone").Elements("Persona")
						join a in altrePersone on new { Nome = q.Attribute("Nome").Value, Cognome = q.Attribute("Cognome").Value } equals new { a.Nome, a.Cognome }
						select new { Nome = q.Attribute("Nome").Value, Cognome = q.Attribute("Cognome").Value };

		var r3 = (from q in doc.Elements("persone").Elements("persona")
						 select new { Nome = q.Attribute("Nome").Value, Cognome = q.Attribute("Cognome").Value })
						 .Intersect(altrePersone.Select(ap => new { ap.Nome, ap.Cognome }));

		grd.DataSource = r;
		grd.DataBind();
	}
}